import * as Redux from 'redux';

export declare namespace Imdux {
    export interface States {
        [key: string]: State<any, any>;
    }

    export interface State<S = any, R = any> {
        initialState: S;
        reducers: R;
    }

    export interface Services {
        [key: string]: Services | service;
    }

    export interface service {
        [key: string]: (args: any) => any;
    }

    export type Draft = (payload: any) => void;

    export interface Reducer {
        [key: string]: Draft | Reducer;
    }

    export type InferState<T extends Imdux.States> = {
        [K in keyof T]: T[K]['initialState'];
    };

    export interface Options {
        name?: string;
        devtool?: boolean; // false
        payloadNotValidWarn?: boolean; // true
    }

    export interface Store<S extends Imdux.States> {
        Dispatch: InferDispatch<S>;
        State: InferState<S>;
        redux: Redux.Store<any, Redux.AnyAction>;
    }

    export type InferDispatch<T extends Imdux.States> = {
        [K in keyof T]: T[K]['reducers'];
    };
}
