export function isPlainObject(obj: any) {
    if (typeof obj !== 'object' || obj === null) return false;
    var proto = obj;

    while (Object.getPrototypeOf(proto) !== null) {
        proto = Object.getPrototypeOf(proto);
    }

    return Object.getPrototypeOf(obj) === proto;
}

export const isPrimitive = (v: any) => typeof v === 'boolean' || typeof v === 'number' || typeof v === 'string' || v === null;

export const isValidPayload = (v: any) => Array.isArray(v) || isPlainObject(v) || isPrimitive(v);
